#ifndef __CHEBY__PLC_URV_REGS__H__
#define __CHEBY__PLC_URV_REGS__H__

#include "mbox_regs.h"
#define PLC_URV_REGS_SIZE 96 /* 0x60 */

/* None */
#define PLC_URV_REGS_MAILBOXES 0x0UL
#define ADDR_MASK_PLC_URV_REGS_MAILBOXES 0x70UL
#define PLC_URV_REGS_MAILBOXES_SIZE 16 /* 0x10 */

/* presence lines for boards */
#define PLC_URV_REGS_PRESENCE 0x10UL
#define PLC_URV_REGS_PRESENCE_EN_MASK 0xffUL
#define PLC_URV_REGS_PRESENCE_EN_SHIFT 0

/* None */
#define PLC_URV_REGS_LOOPS 0x20UL
#define PLC_URV_REGS_LOOPS_SIZE 4 /* 0x4 */

/* None */
#define PLC_URV_REGS_LOOPS_PINS 0x0UL

/* None */
#define PLC_URV_REGS_RELAYS 0x40UL
#define PLC_URV_REGS_RELAYS_SIZE 4 /* 0x4 */

/* None */
#define PLC_URV_REGS_RELAYS_PINS 0x0UL

struct plc_urv_regs {
  /* [0x0]: SUBMAP (no description) */
  struct mbox_regs mailboxes;

  /* padding to: 4 words */
  uint32_t __padding_0[1];

  /* [0x10]: REG (ro) presence lines for boards */
  uint32_t presence;

  /* padding to: 8 words */
  uint32_t __padding_1[3];

  /* [0x20]: REPEAT (no description) */
  struct loops {
    /* [0x0]: REG (ro) (no description) */
    uint32_t pins;
  } loops[8];

  /* [0x40]: REPEAT (no description) */
  struct relays {
    /* [0x0]: REG (rw) (no description) */
    uint32_t pins;
  } relays[8];
};

#endif /* __CHEBY__PLC_URV_REGS__H__ */
